using AbstractFoodOrdersContracts.BindingModels;
using AbstractFoodOrdersContracts.SearchModels;
using AbstractFoodOrdersContracts.StoragesContracts;
using AbstractFoodOrdersContracts.ViewModels;
using AbstractFoodOrdersListImplement.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AbstractFoodOrdersListImplement.Implements
{
    public class OrderStorage : IOrderStorage
    {
        private readonly DataListSingleton _source;
        public OrderStorage()
        {
            _source = DataListSingleton.GetInstance();
        }
        public List<OrderViewModel> GetFullList()
        {
            var result = new List<OrderViewModel>();
            foreach (var order in _source.Orders)
            {
                result.Add(AttachReinforcedName(order.GetViewModel));
            }
            return result;
        }
        public List<OrderViewModel> GetFilteredList(OrderSearchModel model)
        {
            var result = new List<OrderViewModel>();
            if (!model.Id.HasValue && !model.DateFrom.HasValue && !model.DateTo.HasValue && !model.ClientId.HasValue)
            {
                return result;
            }
            foreach (var order in _source.Orders)
            {
                if ((order.DateCreate >= model.DateFrom && order.DateCreate <= model.DateTo) || order.ClientId == model.ClientId)
                {
                    result.Add(AttachReinforcedName(order.GetViewModel));
                }
            }
            return result;

        }
        public OrderViewModel? GetElement(OrderSearchModel model)
        {
            if (!model.Id.HasValue)
            {
                return null;
            }
            foreach (var order in _source.Orders)
            {
                if (model.Id.HasValue && order.Id == model.Id)
                {
                    return AttachReinforcedName(order.GetViewModel);
                }
            }
            return null;

        }
        public OrderViewModel? Insert(OrderBindingModel model)
        {
            model.Id = 1;
            foreach (var order in _source.Orders)
            {
                if (model.Id <= order.Id)
                {
                    model.Id = order.Id + 1;
                }
            }
            var newOrder = Order.Create(model);
            if (newOrder == null)
            {
                return null;
            }
            _source.Orders.Add(newOrder);
            return AttachReinforcedName(newOrder.GetViewModel);
        }
        public OrderViewModel? Update(OrderBindingModel model)
        {
            foreach (var order in _source.Orders)
            {
                if (order.Id == model.Id)
                {
                    order.Update(model);
                    return AttachReinforcedName(order.GetViewModel);
                }
            }
            return null;
        }
        public OrderViewModel? Delete(OrderBindingModel model)
        {
            for (int i = 0; i < _source.Orders.Count; ++i)
            {
                if (_source.Orders[i].Id == model.Id)
                {
                    var element = _source.Orders[i];
                    _source.Orders.RemoveAt(i);
                    return AttachReinforcedName(element.GetViewModel);
                }
            }
            return null;
        }
        private OrderViewModel AttachReinforcedName(OrderViewModel model)
        {
            //Из всех мест, это выглядит наиболее подходящим, для данной манипуляции.
            //При расположении ниже нарушится целостность данных
            //При расположении выше будет нарушен принцип разделения уровней
            foreach (var reinforced in _source.Dishes)
            {
                if (reinforced.Id == model.DishId)
                {
                    model.DishName = reinforced.DishName;
                    break;
                }
            }
            foreach (var client in _source.Clients)
            {
                if (client.Id == model.ClientId)
                {
                    model.ClientFIO = client.ClientFIO;
                    break;
                }
            }
            return model;
        }
    }
}
